pred show {}
run  show for 10


abstract sig Behavior extends Class
{ isReentrant : lone Behavior_isReentrant
, redefinedBehavior : set @Behavior
, precondition : set @Constraint
, postcondition : set @Constraint
, ownedParameterSet : set Behavior_ownedParameterSet }
{}
sig Behavior_isReentrant
{ parent : one Behavior }
{ parent = (Behavior <: isReentrant).this}
sig Behavior_ownedParameterSet extends ParameterSet
{ parent : one Behavior }
{ parent = (Behavior <: ownedParameterSet).this}
abstract sig ParameterSet extends Element
{ parameter : some @Parameter
, condition : set ParameterSet_condition }
{ all  x : (this).(@parameter) | (this) in ((x).(@parameterSet)) }
sig ParameterSet_condition extends Constraint
{ parent : one ParameterSet }
{ parent = (ParameterSet <: condition).this}
abstract sig Parameter extends Element
{ direction : lone ParameterDirectionKind
, isException : lone Parameter_isException
, parameterSet : set @ParameterSet }
{ all  x : (this).(@parameterSet) | (this) in ((x).(@parameter)) }
sig Parameter_isException
{ parent : one Parameter }
{ parent = (Parameter <: isException).this}
abstract sig ParameterDirectionKind
{}
{}
abstract sig DurationConstraint extends Constraint
{ firstEvent : set DurationConstraint_firstEvent }
{  #firstEvent <= 2
  ((#((this).(@constrainedElement))) = (2)) => ((#((this).(@firstEvent))) = (2)) else (no (this).(@firstEvent)) }
sig DurationConstraint_firstEvent
{ parent : one DurationConstraint }
{ parent = (DurationConstraint <: firstEvent).this}
abstract sig OpaqueExpression extends Element
{ behavior = @Behavior }
{ (some (this).(@behavior)) => (no (((((this).(@behavior)).(@ownedParameterSet)).(@parameter)).(@direction))-(@return)) }
abstract sig Reception extends Feature
{ signal = @Signal }
{}
abstract sig Signal extends Classifier
{}
{}
abstract sig Class extends BehavioredClassifier
{ isActive = Class_isActive
, superClass : set @Class
, nestedClassifier : set Class_nestedClassifier
, ownedReception : set Class_ownedReception }
{ (not (some (this).(@isActive))) => (no (this).(@ownedReception)) }
sig Class_isActive
{ parent : one Class }
{ parent = (Class <: isActive).this}
sig Class_nestedClassifier extends Classifier
{ parent : one Class }
{ parent = (Class <: nestedClassifier).this}
sig Class_ownedReception extends Reception
{ parent : one Class }
{ parent = (Class <: ownedReception).this}
abstract sig Constraint extends Element
{ constrainedElement : set @Element }
{}
abstract sig Feature extends Element
{ isStatic : lone Feature_isStatic
, featuringClassifier : set @Classifier }
{ all  x : (this).(@featuringClassifier) | (this) in ((x).(@feature)) }
sig Feature_isStatic
{ parent : one Feature }
{ parent = (Feature <: isStatic).this}
abstract sig BehavioredClassifier extends Classifier
{ classifierBehavior : lone @Behavior }
{}
abstract sig Classifier extends Element
{ isAbstract : lone Classifier_isAbstract
, feature : set @Feature }
{ all  x : (this).(@feature) | (this) in ((x).(@featuringClassifier)) }
sig Classifier_isAbstract
{ parent : one Classifier }
{ parent = (Classifier <: isAbstract).this}
abstract sig Element
{}
{}
one sig kin extends ParameterDirectionKind
{}
{}
one sig inout extends ParameterDirectionKind
{}
{}
one sig out extends ParameterDirectionKind
{}
{}
one sig return extends ParameterDirectionKind
{}
{}
some sig iBehavior extends Behavior
{}
{}
some sig iParameter extends Parameter
{}
{}
some sig iDurationConstraint extends DurationConstraint
{}
{}
some sig iOpaqueExpression extends OpaqueExpression
{}
{}
some sig iFeature extends Feature
{}
{}
some sig iSignal extends Signal
{}
{}
fact { some (@Classifier).(@isAbstract) some (@Class).(@isActive) some (@Class).(@nestedClassifier) some (@Class).(@ownedReception) some (@Behavior).(@isReentrant) some (@Behavior).(@ownedParameterSet) some (@ParameterSet).(@condition) some (@Parameter).(@isException) some (@DurationConstraint).(@firstEvent) some (@Feature).(@isStatic) }
