pred show {}
run  show for 5


abstract sig StateMachine
{ region : some StateMachine_region
, connectionPoint : set StateMachine_connectionPoint
, extendedStateMachine : lone StateMachine }
{}
sig StateMachine_region extends Region
{ parent : one StateMachine }
{ (parent) in ((this).(@stateMachine))
  parent = (StateMachine <: region).this }
sig StateMachine_connectionPoint extends Pseudostate
{ parent : one StateMachine }
{ parent = (StateMachine <: connectionPoint).this}
abstract sig Region
{ subvertex : set Region_subvertex
, transition : set Region_transition
, stateMachine : lone StateMachine
, state : lone State
, extendedRegion : lone Region }
{ all  x : (this).(@stateMachine) | (this) in ((x).(@region))
  all  x : (this).(@state) | (this) in ((x).(@region)) }
sig Region_subvertex extends Vertex
{ parent : one Region }
{ (parent) in ((this).(@container))
  parent = (Region <: subvertex).this }
sig Region_transition extends Transition
{ parent : one Region }
{ (parent) in ((this).(@container))
  parent = (Region <: transition).this }
abstract sig Pseudostate extends Vertex
{ kind : lone PseudostateKind }
{ (((this).(@kind)) = (@initial)) => ((#((this).(@outgoing))) =< (1))
  (((this).(@kind)) in ((@deepHistory)+(@shallowHistory))) => ((#((this).(@outgoing))) =< (1))
  (((this).(@kind)) = (@join)) => ((#((this).(@outgoing))) = (1)) (#((this).(@incoming))) = (2) }
abstract sig PseudostateKind
{}
{}
abstract sig ConnectionPointReference extends Vertex
{ entry : set @Pseudostate
, exit : set @Pseudostate }
{ (some (this).(@entry)) => ((((this).(@entry)).(@kind)) = (@entryPoint))
  (some (this).(@exit)) => ((((this).(@exit)).(@kind)) = (@exitPoint)) }
abstract sig Transition
{ container : one @Region
, source : one @Vertex
, target : one @Vertex }
{ all  x : (this).(@container) | (this) in ((x).(@transition))
  all  x : (this).(@source) | (this) in ((x).(@outgoing))
  all  x : (this).(@target) | (this) in ((x).(@incoming)) }
abstract sig FinalState extends State
{}
{ no (this).(@outgoing)
  no (this).(@region) }
abstract sig State extends Vertex
{ connection : set State_connection
, redefinedState : lone State
, region : set State_region }
{}
sig State_connection extends ConnectionPointReference
{ parent : one State }
{ parent = (State <: connection).this}
sig State_region extends Region
{ parent : one State }
{ (parent) in ((this).(@state))
  parent = (State <: region).this }
abstract sig Vertex
{ container : lone Region
, outgoing : set @Transition
, incoming : set @Transition }
{ all  x : (this).(@container) | (this) in ((x).(@subvertex))
  all  x : (this).(@outgoing) | (this) in ((x).(@source))
  all  x : (this).(@incoming) | (this) in ((x).(@target)) }
one sig deepHistory extends PseudostateKind
{}
{}
one sig shallowHistory extends PseudostateKind
{}
{}
one sig choice extends PseudostateKind
{}
{}
one sig join extends PseudostateKind
{}
{}
one sig exitPoint extends PseudostateKind
{}
{}
one sig terminate extends PseudostateKind
{}
{}
one sig fork extends PseudostateKind
{}
{}
one sig junction extends PseudostateKind
{}
{}
one sig initial extends PseudostateKind
{}
{}
one sig entryPoint extends PseudostateKind
{}
{}
some sig iStateMachine extends StateMachine
{}
{}
some sig iState extends State
{}
{}
one sig iFinalState extends FinalState
{}
{}
fact { some (@StateMachine).(@region) some (@StateMachine).(@connectionPoint) some (@Region).(@subvertex) some (@Region).(@transition) some (@State).(@connection) some (@State).(@region) }
